/**
\page lua_api_entity Map entities

\tableofcontents

Objects placed on the \ref lua_api_map "map"
are called map entities (or just entities).

There exists many types of entities. They can be either declared in the
\ref quest_map_data_file "map data file", or created dynamically by using
the <tt>map:create_*</tt> methods of the \ref lua_api_map
"map API".

\section lua_api_entity_overview Overview

All entities have a position on the map (X, Y and layer)
and a size.
Depending on their type,
they can be visible or not. When they are visible,
they are usually represented by one or several
\ref lua_api_sprite "sprites".
Some entities are fixed, others move according to a
\ref lua_api_movement "movement" object.

Entities can also have a name that uniquely identifies them on the map.
This is useful to access them from the \ref lua_api_map "map API".
The name is optional, but if an entity has a name, it must be unique on the
map.

Here are the existing types of entities.
- \subpage lua_api_hero "Hero": The character controlled by the player.
- \subpage lua_api_tile "Tile": A small brick that composes a piece of the
  \ref lua_api_map "map", with a pattern picked
  from the tileset.
- \subpage lua_api_dynamic_tile "Dynamic tile": A special
  \ref lua_api_tile "tile"
  that can be enabled or disabled dynamically (\ref lua_api_tile "usual tiles"
  are optimized away at runtime).
- \subpage lua_api_teletransporter "Teletransporter": When walking on it, the
  \ref lua_api_hero "hero" is transported somewhere, possibly on
  the same \ref lua_api_map "map" or another map.
- \subpage lua_api_destination "Destination": A possible destination place for
  \ref lua_api_teletransporter "teletransporters".
- \subpage lua_api_pickable "Pickable treasure": A treasure placed on the ground
  and that the \ref lua_api_hero "hero" can pick up.
- \subpage lua_api_destructible "Destructible object": An entity that can be cut
  or lifted by \ref lua_api_hero "hero", and that may hide a
  \ref lua_api_pickable "pickable treasure".
- \subpage lua_api_carried_object "Carried object": Something lifted and
  carried by the \ref lua_api_hero "hero".
- \subpage lua_api_chest "Chest": A chest that contains a treasure.
- \subpage lua_api_shop_treasure "Shop treasure": A treasure that the \ref
  lua_api_hero "hero" can buy for a price.
- \subpage lua_api_enemy "Enemy": A bad guy (possibly a boss) who may also drop
  a \ref lua_api_pickable "pickable treasure" when killed.
- \subpage lua_api_npc "Non-playing character" (NPC): Somebody or something the
  \ref lua_api_hero "hero" can interact with.
- \subpage lua_api_block "Block": An entity that the \ref lua_api_hero "hero"
  can push or pull.
- \subpage lua_api_jumper "Jumper": When walking on it, the \ref lua_api_hero
  "hero" jumps into a direction.
- \subpage lua_api_switch "Switch": A button or another mechanism that the \ref
  lua_api_hero "hero" can activate.
- \subpage lua_api_sensor "Sensor": An invisible detector that detects the
  presence of the \ref lua_api_hero "hero".
- \subpage lua_api_separator "Separator": An horizontal or vertical
  separation between two parts of the map.
- \subpage lua_api_wall "Wall": An invisible object that stops some kinds of
  entities.
- \subpage lua_api_crystal "Crystal": A switch that lowers or raises
  \ref lua_api_crystal_block "crystal blocks".
- \subpage lua_api_crystal_block "Crystal block": A low wall that can be
  lowered
  (travserable) or raised (obstacle) using a \ref lua_api_crystal "crystal".
- \subpage lua_api_stream "Stream": When walking on it, the \ref
  lua_api_hero "hero" automatically moves into a direction.
- \subpage lua_api_door "Door": A door to open with an \ref lua_api_item
  "equipment item" or another condition.
- \subpage lua_api_stairs "Stairs": %Stairs between two \ref lua_api_map "maps"
  or to a platform of a single map.
- \subpage lua_api_bomb "Bomb": A bomb that will explode after a few seconds
  and that may be lifted by the \ref lua_api_hero "hero".
- \subpage lua_api_explosion "Explosion": An explosion that can hurt the
  \ref lua_api_hero "hero" and the \ref lua_api_enemy "enemies".
- \subpage lua_api_fire "Fire": A flame that can hurt
  \ref lua_api_enemy "enemies" and interact with other entities.
- \subpage lua_api_arrow "Arrow": An arrow shot by the bow.
- \subpage lua_api_hookshot "Hookshot": A hookshot shot by the
  \ref lua_api_hero "hero".
- \subpage lua_api_boomerang "Boomerang": A boomerang shot by the
  \ref lua_api_hero "hero".
- \subpage lua_api_camera "Camera": A rectangle that determines the visible
  area of the map.
- \subpage lua_api_custom_entity "Custom entity": An entity fully controlled
  by your Lua scripts.

\remark Note that \ref lua_api_sprite "sprites" and \ref lua_api_movement
"movements" are not map entities, but they can be attached to map entities
(to display them and to move them, respectively).
Sprites and movements can also be used outside a
\ref lua_api_map "map", for example in your title screen or in other
\ref lua_api_menu "menus".

\section lua_api_entity_methods Methods of all entity types

These methods exist in all entity types.

\subsection lua_api_entity_get_type entity:get_type()

Returns the type of entity.
- Return value (string): The type of this entity. Can be one of:
  \c "hero",
  \c "dynamic_tile",
  \c "teletransporter",
  \c "destination",
  \c "pickable",
  \c "destructible",
  \c "carried_object",
  \c "chest",
  \c "shop_treasure",
  \c "enemy",
  \c "npc",
  \c "block",
  \c "jumper",
  \c "switch",
  \c "sensor",
  \c "separator",
  \c "wall",
  \c "crystal",
  \c "crystal_block",
  \c "stream",
  \c "door",
  \c "stairs",
  \c "bomb",
  \c "explosion",
  \c "fire",
  \c "arrow",
  \c "hookshot",
  \c "boomerang" or
  \c "custom_entity".

\remark The type \c "tile" is not is this list because
  \ref lua_api_tile "tiles" don't exist at
  runtime for optimization reasons.

\subsection lua_api_entity_get_map entity:get_map()

Returns the map this entity belongs to.
- Return value (\ref lua_api_map "map"): The map that contains this entity.

\subsection lua_api_entity_get_game entity:get_game()

Returns the game that is running the map this entity belongs to.
- Return value (\ref lua_api_game "game"): The current game.

\subsection lua_api_entity_get_name entity:get_name()

Returns the name of this map entity.

The name uniquely identifies the entity on the map.
- Return value (string): The name of this entity, or \c nil if the
  entity has no name (because the name is optional).

\subsection lua_api_entity_set_name entity:set_name(name)

Sets the name of this map entity.

The name uniquely identifies the entity on the map.
If there is already another entity on the same map with this name, then
a numbered suffix is automatically appended to make sure that entity names
are unique.
- \c name (string or \c nil): The name of this entity, or \c nil to set no name
  (because the name is optional).

\subsection lua_api_entity_exists entity:exists()

Returns whether this entity still exists on the map.

An entity gets destroyed when you call
\ref lua_api_entity_remove "entity:remove()"
or when the engine removes it
(for example an \ref lua_api_enemy "enemy" that gets killed
or a \ref lua_api_pickable "pickable treasure" that gets picked up).
If you refer from Lua to an entity that no longer exists in the C++ side,
this method returns \c false.
- Return value (boolean): \c true if the entity exists, \c false if it was
  destroyed.

\subsection lua_api_entity_remove entity:remove()

Removes this entity from the map and destroys it.

After the entity is destroyed, \ref lua_api_entity_exists
"entity:exists()" returns \c false and there is no reason to keep a
reference to it in the Lua side (though it is harmless).

\subsection lua_api_entity_is_enabled entity:is_enabled()

Returns whether this entity is enabled.

When an entity is disabled, it is not displayed on the map, it does
not move and does not detect collisions.
But it still exists, it still has a position and it can be enabled again later.
- Return value (boolean): \c true if this entity is enabled.

\subsection lua_api_entity_set_enabled entity:set_enabled([enabled])

Enables or disables this entity.

When an entity is disabled, it is not displayed on the map, it does
not move and does not detect collisions.
Its
\ref lua_api_movement "movement",
its
\ref lua_api_sprite "sprites"
and its
\ref lua_api_timer "timers"
if any are suspended and will be resumed when the entity gets enabled again.
While the entity is disabled, it still exists, it still has a position and it
can be enabled again later.
- \c enabled (boolean, optional): \c true to enable the entity, \c false to
  disable it. No value means \c true.

\subsection lua_api_entity_get_size entity:get_size()

Returns the size of the bounding box of this entity.

The
\ref lua_api_entity_get_bounding_box "bounding box" is a rectangle that
determines the position of the entity on the map.
The bounding box is used to detect whether the entity overlaps obstacles or
other entities.
- Return value 1 (number): Width of the entity in pixels.
- Return value 2 (number): Height of the entity in pixels.

\subsection lua_api_entity_set_size entity:set_size(width, height)

Sets the size of the
\ref lua_api_entity_get_bounding_box "bounding box"
of this entity.

This is the effective size used to detect obstacles when moving,
but the \ref lua_api_sprite "sprite(s)"
of the entity may be larger.

The default value depends on the type of entity and is often \c 16x16 pixels.
- \c width (number): Width of the entity in pixels.
- \c height (number): Height of the entity in pixels.

\remark Note that the \ref lua_api_sprite "sprites" of an entity may have a
  different size than the entity itself.
  See
  \ref lua_api_sprite_get_size "sprite:get_size()"
  to know it.

\subsection lua_api_entity_get_origin entity:get_origin()

Returns the origin point of this entity, relative to the upper left corner
of its
\ref lua_api_entity_get_bounding_box "bounding box".

When an entity is located at some coordinates on the \ref lua_api_map "map",
the origin points determines what exact point of the entity's bounding box
is at those coordinates.
It is not necessarily the upper left corner of the entity's
bounding box.

The default origin point depends on the type of entity.
By convention, it is usually be the central point of contact between the entity
and the soil.
For most entities, including
the \ref lua_api_hero "hero",
\ref lua_api_enemy "enemies",
\ref lua_api_npc "non-playing characters"
and
\ref lua_api_custom_entity "custom entities",
the default origin point is <tt>8, 13</tt>
as their default size is <tt>16x16</tt>.
More generally, the convention is to have an origin point of
<tt>width / 2, height - 3</tt>.

This origin point property allows entities of different sizes to have
comparable reference points.
Indeed, when two entities to be
drawn in Y order overlap,
the engine needs to determine which one
has to be displayed first
(it is always the one with the lowest Y coordinate).
Using the upper left corner Y coordinate for this would not work well with
entities of different sizes.

Similarly, if you need to compute an
\ref lua_api_entity_get_angle "angle" between two entities
to move an entity away from another one,
the calculation uses the origin point of both entities.
Using the upper left corner of their bounding box would not give the
accurate angle with entities of different sizes.

The origin point is also the point of synchronization of an entity with its
\ref lua_api_sprite "sprites" (because again, an entity that has a given
size may have sprites with different sizes).
- Return value 1 (number): X coordinate of the origin point in pixels,
  relative to the upper left corner of the entity's bounding box.
- Return value 2 (number): Y coordinate of the origin point in pixels,
  relative to the upper left corner of the entity's bounding box.

\subsection lua_api_entity_set_origin entity:set_origin(origin_x, origin_y)

Sets the origin point of this entity, relative to the upper left corner
of its
\ref lua_api_entity_get_bounding_box "bounding box".

See \ref lua_api_entity_get_origin "entity:get_origin()" for details
about the origin point.
- \c origin_x (number): X coordinate of the origin point in pixels,
  relative to the upper left corner of the entity's bounding box.
- \c origin_y (number): Y coordinate of the origin point in pixels,
  relative to the upper left corner of the entity's bounding box.

\remark When you call this method,
  the bounding box of the entity is moved so that coordinates
  (as returned by
  \ref lua_api_entity_get_position "entity:get_position()")
  do not change.
  If this is not what you need, you can call
  \ref lua_api_entity_set_position "entity:set_position()" then to adjust the
  entity's position to the coordinates you want.

\subsection lua_api_entity_get_position entity:get_position()

Returns the position of this entity on the \ref lua_api_map "map"
(coordinates and layer).
- Return value 1 (number): X coordinate of the \ref lua_api_entity_get_origin
  "origin point" of the entity,
  relative to the upper left corner of the map.
- Return value 2 (number): Y coordinate of the \ref lua_api_entity_get_origin
  "origin point" of the entity,
  relative to the upper left corner of the map.
- Return value 3 (number): Layer where the entity is on the map, between
  \ref lua_api_map_get_min_layer "map:get_min_layer()" and
  \ref lua_api_map_get_max_layer "map:get_max_layer()".

\subsection lua_api_entity_set_position entity:set_position(x, y, [layer])

Changes instantly the position of this entity on the map
(coordinates and layer).
The \ref lua_api_entity_get_origin "origin point" of the
entity gets placed at these coordinates,
relative to the map's upper left corner.
Any previous movement or other action performed by the entity
continues normally.
- \c x (number): X coordinate to set.
- \c y (number): Y coordinate to set.
- \c layer (number, optional): Layer to set, between
  \ref lua_api_map_get_min_layer "map:get_min_layer()" and
  \ref lua_api_map_get_max_layer "map:get_max_layer()".
  By default, the layer is unchanged.

\remark Be careful: this function does not check collisions with obstacles.

\subsection lua_api_entity_get_center_position entity:get_center_position()

Returns the coordinates of the center point of this entity on the
\ref lua_api_map "map".
- Return value 1 (number): X coordinate of the center of this entity's
  bounding box,
  relative to the upper left corner of the map.
- Return value 2 (number): Y coordinate of the center of this entity's
  bounding box,
  relative to the upper left corner of the map.
- Return value 3 (number): Layer of the entity.

\subsection lua_api_entity_get_facing_position entity:get_facing_position()

Returns the coordinates of the point this entity is looking at.
This point depends on the direction of the main sprite if any.
If the entity has no sprite, or if the main sprite has not 4 directions,
then the movement is considered.
If there is no movement either, the entity is assumed to look to the North.
- Return value 1 (number): X coordinate of the facing point of this entity,
  relative to the upper left corner of the map.
- Return value 2 (number): Y coordinate of the facing point of this entity,
  relative to the upper left corner of the map.
- Return value 3 (number): Layer of the entity.

\subsection lua_api_entity_get_facing_entity entity:get_facing_entity()

Returns the entity this entity is looking at, if any.

This is an entity overlapping the
\ref lua_api_entity_get_facing_position "facing position" of this entity.
If several entities are overlapping the facing position,
the first one in Z order is returned.
- Return value (entity): The facing entity, or \c nil
  if there is no entity in front of this entity.

\subsection lua_api_entity_get_ground_position entity:get_ground_position()

Returns the coordinates of the point used for ground detection for this
entity on the \ref lua_api_map "map".

The ground position is the point tested by all features related to the ground,
like all effects of various grounds on the
\ref lua_api_hero "hero",
the result of
\ref lua_api_entity_get_ground_below "entity:get_ground_below()"
and the event
\ref lua_api_custom_entity_on_ground_below_changed
"custom_entity:on_ground_below_changed()".
- Return value 1 (number): X coordinate of the ground point of this entity,
  relative to the upper left corner of the map.
- Return value 2 (number): Y coordinate of the ground point of this entity,
  relative to the upper left corner of the map.
- Return value 3 (number): Layer of the entity.

\remark The ground point of an entity is slightly (2 pixels)
  above its origin point as returned by
  \ref lua_api_entity_get_position "entity:get_position()".

\subsection lua_api_entity_get_ground_below entity:get_ground_below()

Returns the map's ground below this entity.

The ground is defined by the topmost
\ref lua_api_tile "tile" below this entity,
plus potential dynamic entities that may affect the ground,
like
\ref lua_api_dynamic_tile "dynamic tiles",
\ref lua_api_destructible "destructibles"
and
\ref lua_api_custom_entity "custom entities".

The exact point tested is the one returned by
\ref lua_api_entity_get_ground_position "entity:get_ground_position()",
and it is slightly different from
\ref lua_api_entity_get_position "entity:get_position()".
- Return value (string): The ground below this entity.
  See \ref lua_api_map_get_ground "map:get_ground()" for the list of possible grounds.

\subsection lua_api_entity_get_bounding_box entity:get_bounding_box()

Returns the rectangle representing the
\ref lua_api_entity_get_position "coordinates"
and
\ref lua_api_entity_get_size "size" of this entity
on the
\ref lua_api_map "map".

The
\ref lua_api_entity_get_bounding_box "bounding box" is a rectangle that
determines the position of the entity on the map.
The bounding box is used to detect whether the entity overlaps obstacles or
other entities.
- Return value 1 (number): X coordinate of the upper left corner of the
  bounding box.
- Return value 2 (number): Y coordinate of the upper left corner of the
  bounding box.
- Return value 3 (number): Width of the bounding box.
- Return value 4 (number): Height of the bounding box.

\remark The sprites of this entity (if any) may exceed the bounding box.
  See
  \ref lua_api_entity_get_max_bounding_box
  "entity:get_max_bounding_box()".

\subsection lua_api_entity_get_max_bounding_box entity:get_max_bounding_box()

Returns the rectangle surrounding the bounding box of this entity
plus the bounding boxes of its sprites
in all their possible animations and directions.

This is usually larger than
\ref lua_api_entity_get_bounding_box
"entity:get_bounding_box()", because the sprite of an entity often
exceeds its bounding box.
- Return value 1 (number): X coordinate of the upper left corner of the
  sprites bounding box.
- Return value 2 (number): Y coordinate of the upper left corner of the
  sprites bounding box.
- Return value 3 (number): Width of the sprites bounding box.
- Return value 4 (number): Height of the sprites bounding box.

\subsection lua_api_entity_get_layer entity:get_layer()

Returns the layer of this entity on the \ref lua_api_map "map".
- Return value (number): Layer where the entity is on the map, between
  \ref lua_api_map_get_min_layer "map:get_min_layer()" and
  \ref lua_api_map_get_max_layer "map:get_max_layer()".

\subsection lua_api_entity_set_layer entity:set_layer(layer)

Changes the layer of this entity on the map.
The X and Y coordinates of the entity are unchanged.
Any previous movement or action performed by the entity continues normally.
- \c layer (number, optional): Layer to set, between
  \ref lua_api_map_get_min_layer "map:get_min_layer()" and
  \ref lua_api_map_get_max_layer "map:get_max_layer()".

\remark Be careful: this function does not check collisions with obstacles.

\subsection lua_api_entity_overlaps_rectangle entity:overlaps(x, y, [width, height])

Returns whether the
\ref lua_api_entity_get_bounding_box "bounding box"
of this entity overlaps the specified rectangle or point.

To test if this entity overlaps a rectangle or a point (a point is a rectangle
of size 1x1):
- \c x (number): X coordinate of the upper left corner of the rectangle
  to check.
- \c y (number): Y coordinate of the upper left corner of the rectangle
  to check.
- \c width (number, optional): Width of the rectangle (default \c 1).
- \c height (number, optional): Height of the rectangle (default \c 1).
- Return value (boolean): \c true if the bounding box of this entity overlaps
  the rectangle.

\subsection lua_api_entity_overlaps_entity entity:overlaps(other_entity, [collision_mode, [entity_sprite, [other_entity_sprite]]])

Returns whether another entity collides with this entity according to
the specified collision test.
- \c other_entity (entity): Another entity.
- \c collision_mode (string, optional): Specifies what kind of collision you
  want to test. This may be one of:
  - \c "overlapping": Collision if the
    \ref lua_api_entity_get_bounding_box "bounding box"
    of both entities overlap.
    This is the default value.
  - \c "containing": Collision if the bounding box of the other entity is
    fully inside the bounding box of this entity.
  - \c "origin": Collision if the \ref lua_api_entity_get_origin "origin point"
    or the other entity is inside the bounding box of this entity.
  - \c "center": Collision if the \ref lua_api_entity_get_center_position
    "center point" of the other entity is inside the bounding box of this
    entity.
  - \c "facing": Collision if the
    \ref lua_api_entity_get_facing_position "facing position" of the other
    entity's bounding box is touching this entity's bounding box.
    Bounding boxes don't necessarily overlap, but they are in
    contact: there is no space between them.
    When you consider the bounding box of an entity,
    which is a rectangle with four sides,
    the facing point is the middle point of the side the entity is oriented to.
    This \c "facing" collision test is useful when the other entity cannot
    traverse your custom entity.
    For instance, if the other entity has direction "east", there is a
    collision if the middle of the east side of its bounding box touches
    (but does not necessarily overlap) this entity's bounding box.
    This is typically what you need to let the hero interact with
    this entity when he is looking at it.
  - \c "touching": Like \c "facing", but accepts all four sides of the other
    entity's bounding box, no matter its direction.
  - \c "sprite": Collision if a sprite of the other entity overlaps a sprite of
    this entity.
    The collision test is pixel precise.
    The last two optional sprite parameters can then indicate which sprite of
    both entities you want to test.
    If you don't set them, all sprites of both entities will be tested.
- \c entity_sprite (\ref lua_api_sprite "sprite" or nil, optional):
  Sprite of this entity you want to test
  (only with collision mode \c "sprite").
  \c nil or no value means to test all sprites of this entity.
- \c other_entity_sprite (\ref lua_api_sprite "sprite" or nil, optional):
  Sprite of the other entity you want to test
  (only with collision mode \c "sprite").
  \c nil or no value means to test all sprites of the other entity.
- Return value (boolean): \c true if a collision is detected with this collision test.

\remark For custom entities, see also
  \ref lua_api_custom_entity_add_collision_test
  "custom_entity:add_collision_test()"
  to be automatically notified when a collision is detected.

\subsection lua_api_entity_get_distance entity:get_distance(x, y), entity:get_distance(other_entity)

Returns the distance in pixels between this map entity and a point or another
map entity.

To compute the distance to a specified point:
- \c x (number): X coordinate of the point.
- \c y (number): Y coordinate of the point.
- Return value (number): The distance in pixels between the origin point of
  this entity and the point.

To compute the distance to another map entity:
- \c other_entity (entity): The entity to compute the distance to.
- Return value (number): The distance in pixels between the origin point of
  this entity and the origin point of the other entity.

\subsection lua_api_entity_get_angle entity:get_angle(x, y), entity:get_angle(other_entity)

Returns the angle between the X axis and the vector that joins this entity
to a point.

To compute the angle to a specified point:
- \c x (number): X coordinate of the point.
- \c y (number): Y coordinate of the point.
- Return value (number): The angle in radians between the origin point of
  this entity and the specified point.
  The angle is between \c 0 and <tt>2 * math.pi</tt>.

To compute the angle to another map entity:
- \c other_entity (entity): The entity to compute the angle to.
- Return value (number): The angle in radians between the origin point of
  this entity and the origin point of the other entity.
  The angle is between \c 0 and <tt>2 * math.pi</tt>.

\subsection lua_api_entity_get_direction4_to entity:get_direction4_to(x, y), entity:get_direction4_to(other_entity)

Like
\ref lua_api_entity_get_angle "entity:get_angle()",
but instead of an angle in radians,
returns the closest direction among the 4 main directions.

This is a utility function that essentially rounds the result of
\ref lua_api_entity_get_angle "entity:get_angle()".

To compute the direction to a specified point:
- \c x (number): X coordinate of the point.
- \c y (number): Y coordinate of the point.
- Return value (number): The direction this entity should take to look at
  this point, between 0 (East) and 3 (South).

To compute the direction to another map entity:
- \c other_entity (entity): An entity to target.
- Return value (number): The direction this entity should take to look at
  the other entity, between 0 (East) and 3 (South).

\subsection lua_api_entity_get_direction8_to entity:get_direction8_to(x, y), entity:get_direction8_to(other_entity)

Like
\ref lua_api_entity_get_angle "entity:get_angle()",
but instead of an angle in radians,
returns the closest direction among the 8 main directions.

This is a utility function that essentially rounds the result of
\ref lua_api_entity_get_angle "entity:get_angle()".

To compute the direction to a specified point:
- \c x (number): X coordinate of the point.
- \c y (number): Y coordinate of the point.
- Return value (number): The direction this entity should take to look at
  this point, between 0 (East) and 7 (South-East).

To compute the direction to another map entity:
- \c other_entity (entity): An entity to target.
- Return value (number): The direction this entity should take to look at
  the other entity, between 0 (East) and 7 (South-East).

\subsection lua_api_entity_snap_to_grid entity:snap_to_grid()

Makes sure this entity's upper left corner is aligned with the 8*8 grid
of the \ref lua_api_map "map".

\remark Be careful: this function does not check collisions with obstacles.

\subsection lua_api_entity_bring_to_front entity:bring_to_front()

Places this entity in front of all other entities on the same layer.

Since entities that are on the same layer can overlap,
you can use this function to change their Z order.

\remark Some entities can have
  have the property to be
  \ref lua_api_entity_is_drawn_in_y_order "drawn in Y order"
  rather than in Z order.
  This function only has an effect on entities drawn in Z order.

\subsection lua_api_entity_bring_to_back entity:bring_to_back()

Places this entity behind all other entities on the same layer.

Since entities that are on the same layer can overlap,
you can use this function to change their Z order.

\remark Some entities can have
  have the property to be
  \ref lua_api_entity_is_drawn_in_y_order "drawn in Y order"
  rather than in Z order.
  This function only has an effect on entities drawn in Z order.

\subsection lua_api_entity_is_drawn_in_y_order entity:is_drawn_in_y_order()

Returns whether this entity should be drawn in Y order or in Z order.

The map is drawn layer by layer, and each layer is drawn in two passes:
first, entities displayed in Z order, and then,
entities displayed in Y order.

The Z order is the creation order of entities unless you call
\ref lua_api_entity_bring_to_front "entity:bring_to_front()"
or
\ref lua_api_entity_bring_to_back "entity:bring_to_back()".

The Y order compares the Y coordinate of entities on the map.
Entities drawn in Y order are displayed from the one the most to the
north to the one the most to the south.

Usually, entities representing a character or something that is standing
should be drawn in Y order, so that it looks correct when some of them overlap
with each other,
and flat entities should be drawn in Z order.

The default setting depends on the type of entities.
- Return value (boolean): \c true if this entity is displayed in Y
  order, \c false if it is displayed in Z order.

\subsection lua_api_entity_set_drawn_in_y_order entity:set_drawn_in_y_order([y_order])

Sets whether this entity should be drawn in Y order or in Z order.

See \ref lua_api_entity_is_drawn_in_y_order "entity:is_drawn_in_y_order()" for
details about the Y order and the Z order.
- \c y_order (boolean, optional): \c true to display this entity in Y
  order, \c false to display it in Z order.
  No value means \c true.

\subsection lua_api_entity_get_optimization_distance entity:get_optimization_distance()

Returns the optimization threshold hint of this map entity.

Above this distance from the camera, the engine may decide to skip updates or
drawings.
This is only a hint: the engine is responsible of the final decision.
A value of \c 0 means an infinite distance (the entity is never optimized away).
- Return value (number): The optimization distance hint in pixels.

\subsection lua_api_entity_set_optimization_distance entity:set_optimization_distance(optimization_distance)

Sets the optimization threshold hint of this map entity.

Above this distance from the camera, the engine may decide to skip updates or
drawings.
This is only a hint: the engine is responsible of the final decision.

A value of \c 0 means an infinite distance (the entity is never optimized away).
The default value is \c 0.
- \c optimization_distance (number): The optimization distance hint to set in pixels.

\subsection lua_api_entity_is_in_same_region entity:is_in_same_region(x, y), entity:is_in_same_region(other_entity)

Returns whether this entity is in the same region as a position or another entity.

Regions of the map are defined by the position of
\ref lua_api_separator "separators" and map limits.
The region of an entity is the one of its center point.

Regions should be rectangular.
Non-convex regions, for example with an "L" shape, are not supported by this
function.

You can use this function to make sure that an entity is in the same region as an arbitrary point.
- \c x (number): X coordinate of the point.
- \c y (number): Y coordinate of the point.
- Return value (boolean): \c true if the entity is in the same region as the position.

You can use this function to make sure that an
\ref lua_api_enemy "enemy" close to the
\ref lua_api_hero "hero" but in the other side of a separator won't attack the hero.
- \c other_entity (entity): Another entity.
- Return value (boolean): \c true if both entities are in the same region.

\subsection lua_api_entity_test_obstacles entity:test_obstacles([dx, dy, [layer]])

Returns whether there would be a collision with obstacles
if this map entity was placed at a given offset from its current position.
- \c dx (number, optional): X offset in pixels
  (\c 0 means the current X position).
  No value means \c 0.
- \c dy (number, optional): Y offset in pixels
  (\c 0 means the current Y position).
  No value means \c 0.
- \c layer (number, optional): Layer to test.
  No value means the current layer.
- Return value (boolean): \c true if there would be a collision in this
position.

\subsection lua_api_entity_get_sprite entity:get_sprite([name])

Returns a \ref lua_api_sprite "sprite" representing this entity.

To manage entities with multiple sprites, you can set names
when you create sprites with
\ref lua_api_entity_create_sprite "entity:create_sprite()".
However, it is easier to just leave the names blank and simply store the
result of these sprite creation methods.
The name is more useful for built-in entities that have multiple
sprites automatically created by the engine.
Such entities are the
\ref lua_api_hero "hero",
\ref lua_api_pickable "pickable treasures",
\ref lua_api_carried_object "carried objects"
and
\ref lua_api_crystal "crystals".
See the documentation pages of these entities to know their exact sprites,
the name of these sprites and which one is their main sprite.
For
\ref lua_api_enemy "enemies"
and
\ref lua_api_custom_entity "custom entities",
the main sprite is the first one in Z order,
which is the sprite creation order unless you
call
\ref lua_api_entity_bring_sprite_to_front "entity:bring_sprite_to_front()"
or
\ref lua_api_entity_bring_sprite_to_back "entity:bring_sprite_to_back()".

- \c name (string, optional): Name of the sprite to get.
  Only useful for entities that have multiple sprites.
  No value means the main sprite.
- Return value (\ref lua_api_sprite "sprite"): The entity sprite with this name,
  or its main sprite if no name is specified.
  Returns \c nil if the entity has no such sprite.

\subsection lua_api_entity_get_sprites entity:get_sprites()

Returns an iterator to all
\ref lua_api_sprite "sprites" of this entity.

At each step, the iterator provides two values:
the name of a sprite
(which is an empty string if the sprite has no name)
and the sprite itself.
See \ref lua_api_entity_get_sprite "entity:get_sprite()"
for more details about named sprites.

Sprites are returned in their displaying order.
Note that this order can be changed with
\ref lua_api_entity_bring_sprite_to_front "entity:bring_sprite_to_front()"
and
\ref lua_api_entity_bring_sprite_to_back "entity:bring_sprite_to_back()".

The typical usage of this function is:
\verbatim
for sprite_name, sprite in entity:get_sprites() do
  -- some code related to the sprite
end
\endverbatim
- Return value (function): An iterator to all sprites of this entity.

\subsection lua_api_entity_create_sprite entity:create_sprite(animation_set_id, [sprite_name])

Creates a \ref lua_api_sprite "sprite" for this entity.
- \c animation_set_id (string): Animation set to use for the sprite.
- \c sprite_name (string, optional): An optional name to identify the created
  sprite. Only useful for entities with multiple sprites (see
  \ref lua_api_entity_get_sprite "entity:get_sprite()").
- Return value (\ref lua_api_sprite "sprite"): The sprite created.

\subsection lua_api_entity_remove_sprite entity:remove_sprite([sprite])

Removes and destroys a
\ref lua_api_sprite "sprite" of this entity.
- \c sprite (\ref lua_api_sprite "sprite", optional): The sprite to remove.
  The default value is the first sprite that was created.

\subsection lua_api_entity_bring_sprite_to_front entity:bring_sprite_to_front(sprite)

Reorders a
\ref lua_api_sprite "sprite" of this entity to be displayed after other sprites
(displayed to the front).

This function is only useful for entities that have multiple sprites.
- \c sprite (\ref lua_api_sprite "sprite"): The sprite to reorder.
  It must belong to this entity.

\subsection lua_api_entity_bring_sprite_to_back entity:bring_sprite_to_back(sprite)

Reorders a
\ref lua_api_sprite "sprite" of this entity to be displayed before other sprites
(displayed to the back).

This function is only useful for entities that have multiple sprites.
- \c sprite (\ref lua_api_sprite "sprite"): The sprite to reorder.
  It must belong to this entity.

\subsection lua_api_entity_is_visible entity:is_visible()

Returns whether this entity is visible.

When the entity is hidden, its sprites (if any) are not displayed, but
everything else continues normally, including collisions.
- Return value (boolean): \c true if the entity is visible.

\subsection lua_api_entity_set_visible entity:set_visible([visible])

Hides or shows the entity.

When the entity is hidden, its sprites (if any) are not displayed, but
everything else continues normally, including collisions.
- \c visible (boolean, optional): \c true to show the entity, \c false to hide
  it. No value means \c true.

\subsection lua_api_entity_get_draw_override entity:get_draw_override()

Returns the draw function of this entity.

See \ref lua_api_entity_set_draw_override "entity:set_draw_override()"
for more details.
- Return value (function or nil): The draw function, or \c nil if the draw
  function was not overridden.

\subsection lua_api_entity_set_draw_override entity:set_draw_override(draw_override)

Changes how this entity is drawn.

You can use this to replace the built-in draw implementation of the engine by
your own function, if the default behavior does not fit your needs.
To do so, your function can either call
\ref lua_api_map_draw_visual "map:draw_visual()"
or draw on \ref lua_api_camera "camera:get_surface()".
- \c draw_override (function or nil): The draw function, or \c nil to
  restore the built-in drawing.
  Your function will receive the following parameters:
  - \c entity (entity): The entity to draw.
  - \c camera (\ref lua_api_camera "camera"): Camera where this entity is drawn.

\remark Even when you set a draw override, events
  \ref lua_api_entity_on_pre_draw "entity:on_pre_draw()" and
  \ref lua_api_entity_on_post_draw "entity:on_post_draw()" are still called.

\subsection lua_api_entity_get_weight entity:get_weight()

Returns the weight of this entity, if any.

If the entity has a weight, then the
\ref lua_api_hero "hero" is allowed to lift it if his
\ref lua_api_game_get_ability "lift ability"
is greater than or equal to that weight.
You can use
\ref lua_api_entity_on_lifting "entity:on_lifting()" to know when
an entity starts being lifted.

The default weight depends on the type of entity.
Most entities cannot be lifted by default.
- Return value (number): The level of \c "lift" ability required to lift this
  entity.
  \c 0 allows the
  \ref lua_api_hero "hero" to lift the entity unconditionally.
  The special value \c -1 means that the entity can never be lifted.

\subsection lua_api_entity_set_weight entity:set_weight(weight)

Sets the weight of this entity.

See
\ref lua_api_entity_get_weight "entity:get_weight()" for more details.
- \c weight (number): The level of \c "lift" ability required to lift this
  entity.
  \c 0 allows the
  \ref lua_api_hero "hero" to lift the entity unconditionally.
  The special value \c -1 means that the entity can never be lifted.

\subsection lua_api_entity_get_controlling_stream entity:get_controlling_stream()

Returns the \ref lua_api_stream "stream"
that is currently controlling this entity, if any.
- Return value (\ref lua_api_stream "stream"): The current stream,
  or \c nil if this entity is not being controlled by a stream.

\subsection lua_api_entity_get_movement entity:get_movement()

Returns the current movement of this map entity.
- Return value (\ref lua_api_movement "movement"): The current movement,
  or \c nil if the entity has currently no movement.

\note Even when the entity is not moving, it can still have a movement of
  speed \c 0.

\subsection lua_api_entity_stop_movement entity:stop_movement()

Stops the current movement of this map entity if any.

\subsection lua_api_entity_get_property entity:get_property(key)

Returns the value of a user-defined property of this entity.

User-defined properties are arbitrary key-value pairs that you can set to
any entity.
The engine does nothing special with them, but you can use them in your scripts
to store extra information.
- \c key (string): Name of the property to get.
- Return value (string): The corresponding value,
  or \c nil if there is no such property.

\subsection lua_api_entity_set_property entity:set_property(key, value)

Sets a user-defined property for this entity.

If the property does not exist yet, it will be created.

User-defined properties are arbitrary key-value pairs that you can set to
any entity.
The engine does nothing special with them, but you can use them in your scripts
to store extra information.
- \c key (string): Name of the property to set.
  It must be a valid identifier
  (only alphanumeric ASCII characters or \c '_').
- \c value (string or nil): The value to set,
  or \c nil to remove the property.

\subsection lua_api_entity_get_properties entity:get_properties()

Returns the user-defined properties of this entity.
- Return value (table): An array of properties.
  Each property is a table with two fields:
  - \c key (string): Name of the property.
  - \c value (string): Value of the property.

\subsection lua_api_entity_set_properties entity:set_properties(properties)

Sets the user-defined properties of this entity.

Existing properties if any are removed.
- \c properties (table): An array of properties.
  Each property is a table with two fields:
  - \c key (string): Name of the property.
    It must be a valid identifier
    (only alphanumeric ASCII characters or \c '_').
  - \c value (string): Value of the property.

\section lua_api_entity_events Events of all entity types

Events are callback methods automatically called by the engine if you define
them.

\subsection lua_api_entity_on_created entity:on_created()

Called when this entity has just been created on the map.

\subsection lua_api_entity_on_removed entity:on_removed()

Called when this entity is about to be removed from the map
(and therefore destroyed).

\subsection lua_api_entity_on_enabled entity:on_enabled()

called when this entity has just been
\ref lua_api_entity_is_enabled "enabled".

\subsection lua_api_entity_on_disabled entity:on_disabled()

called when this entity has just been
\ref lua_api_entity_is_enabled "disabled".

\subsection lua_api_entity_on_suspended entity:on_suspended(suspended)

Called when the entity has just been suspended or resumed.

The entity is suspended by the engine in a few cases, like when the \ref
lua_api_game "game" is
paused or when a dialog is active.
When this happens, all \ref lua_api_entity "map entities" stop moving and most
\ref lua_api_sprite "sprites" stop their animation.
- \c suspended (boolean): \c true if the entity was just suspended,
  \c false if it was resumed.

\subsection lua_api_entity_on_position_changed entity:on_position_changed(x, y, layer)

Called when the coordinates of this entity have just changed.
- \c x (number): The new X coordinate of the entity.
- \c y (number): The new Y coordinate of the entity.
- \c layer (number): The new layer of the entity.

\subsection lua_api_entity_on_obstacle_reached entity:on_obstacle_reached(movement)

Called when the \ref lua_api_movement "movement"
of this entity was stopped because of an obstacle.

When an obstacle is reached, this event is called instead of
\ref lua_api_entity_on_position_changed "entity:on_position_changed()".
- \c movement (\ref lua_api_movement "movement"): The movement of the entity.

\subsection lua_api_entity_on_movement_started entity:on_movement_started(movement)

Called when a
\ref lua_api_movement "movement"
is started on this entity.
- \c movement (\ref lua_api_movement "movement"): The movement that was just
  started on this entity.

\subsection lua_api_entity_on_movement_changed entity:on_movement_changed(movement)

Called when some characteristics of this entity's
\ref lua_api_movement "movement"
(like the speed or the angle) have just changed.
- \c movement (\ref lua_api_movement "movement"): The movement of the entity.

\subsection lua_api_entity_on_movement_finished entity:on_movement_finished()

Called when the
\ref lua_api_movement "movement"
of the entity is finished (if there is an end).

\subsection lua_api_entity_on_lifting entity:on_lifting(carrier, carried_object)

Called when this entity starts being lifted.

At this point, the \ref lua_api_hero "hero" is in
\ref lua_api_hero_get_state "state" \c "lifting".
The animation \c "lifting" of his sprites is playing and the player
cannot control the hero.

This entity no longer exists (unless it is a destructible object that can
\ref lua_api_destructible_get_can_regenerate "regenerate").
It is replaced by a
\ref lua_api_carried_object "carried object" with the same sprite.
- \c carrier (\ref lua_api_entity "entity"): Entity that is lifting this
destructible object (can only be the \ref lua_api_hero "hero" for now).
- \c carried_object (\ref lua_api_carried_object "carried object"): The carried
  object that was created.

\subsection lua_api_entity_on_pre_draw entity:on_pre_draw(camera)

Called just before the entity is drawn on the map.

You may display additional things below the entity.
To do so, you can either call
\ref lua_api_map_draw_visual "map:draw_visual()"
or draw on \ref lua_api_camera "camera:get_surface()".
- \c camera (\ref lua_api_camera "camera"): The camera where this entity is
  being drawn.

\subsection lua_api_entity_on_post_draw entity:on_post_draw(camera)

Called just after the entity is drawn on the map.

You may display additional things above the entity.
To do so, you can either call
\ref lua_api_map_draw_visual "map:draw_visual()"
or draw on \ref lua_api_camera "camera:get_surface()".
- \c camera (\ref lua_api_camera "camera"): The camera where this entity is
  being drawn.

*/
